(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@yukawa/chain-base-angular-store'), require('rxjs'), require('@angular/core'), require('@angular/material/paginator'), require('@angular/material/sort'), require('@yukawa/chain-crm-angular-core'), require('@angular/router'), require('@angular/cdk/overlay'), require('@angular/forms'), require('@angular/common'), require('@angular/flex-layout'), require('@ngx-translate/core'), require('@angular/common/http'), require('@angular/cdk/table'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/core'), require('@angular/material/slide-toggle'), require('@angular/material/table'), require('@angular/material/tooltip'), require('@angular/material/menu'), require('@angular/material/checkbox'), require('@angular/material/datepicker')) :
    typeof define === 'function' && define.amd ? define('@yukawa/chain-crm-angular-comp', ['exports', '@yukawa/chain-base-angular-store', 'rxjs', '@angular/core', '@angular/material/paginator', '@angular/material/sort', '@yukawa/chain-crm-angular-core', '@angular/router', '@angular/cdk/overlay', '@angular/forms', '@angular/common', '@angular/flex-layout', '@ngx-translate/core', '@angular/common/http', '@angular/cdk/table', '@angular/material/button', '@angular/material/icon', '@angular/material/core', '@angular/material/slide-toggle', '@angular/material/table', '@angular/material/tooltip', '@angular/material/menu', '@angular/material/checkbox', '@angular/material/datepicker'], factory) :
    (global = global || self, factory((global.yukawa = global.yukawa || {}, global.yukawa['chain-crm-angular-comp'] = {}), global.chainBaseAngularStore, global.rxjs, global.ng.core, global.ng.material.paginator, global.ng.material.sort, global.chainCrmAngularCore, global.ng.router, global.ng.cdk.overlay, global.ng.forms, global.ng.common, global.ng['flex-layout'], global.core$1, global.ng.common.http, global.ng.cdk.table, global.ng.material.button, global.ng.material.icon, global.ng.material.core, global.ng.material['slide-toggle'], global.ng.material.table, global.ng.material.tooltip, global.ng.material.menu, global.ng.material.checkbox, global.ng.material.datepicker));
}(this, (function (exports, chainBaseAngularStore, rxjs, core, paginator, sort, chainCrmAngularCore, router, overlay, forms, common, flexLayout, core$1, http, table, button, icon, core$2, slideToggle, table$1, tooltip, menu, checkbox, datepicker) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var AccountQueryStore = /** @class */ (function (_super) {
        __extends(AccountQueryStore, _super);
        function AccountQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        /**
         * @protected
         * @return {?}
         */
        AccountQueryStore.prototype.queryTable = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryAccount(filter);
            //   var data = {
            //       "op" : "query",
            //       "fqn" : "bf-questionnaire-data",
            //       "stamp" : "2020-08-13T20:40:23.292+0000",
            //       "rows" : 3,
            //       "hasMore" : false,
            //       "messages" : [ {
            //           "code" : "OK",
            //           "type" : "duration",
            //           "level" : 1,
            //           "text" : "OK 1ms"
            //       } ],
            //       "items" : [
            //           {"name": "SAP", "owner": "Dietmar"},
            //           {"name": "Siemens", "owner": "Joe"},
            //           {"name": "Wirecard", "owner": "Jan"}
            //       ],
            //       "took" : 1
            //   }
            // return of(data);
        };
        return AccountQueryStore;
    }(chainBaseAngularStore.QueryTableSource));
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        AccountQueryStore.prototype.service;
        /**
         * @type {?}
         * @protected
         */
        AccountQueryStore.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        AccountQueryStore.prototype.sort;
        /**
         * @type {?}
         * @protected
         */
        AccountQueryStore.prototype.tableFilter;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    ;
    /** @type {?} */
    var TAG = "AccountTableComponent";
    var AccountTableComponent = /** @class */ (function () {
        function AccountTableComponent(service) {
            this.service = service;
            this.displayedColumns = ['lastName', 'firstName', 'companyName', 'role', 'preferredCommunicationChannel'];
            this.customColumns = [];
            this.action = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        AccountTableComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                /** @type {?} */
                var abc = this.customColumns.map((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) { return c.columnDef; }));
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
                this.displayedColumns.push("actions");
            }
            else {
                this.displayedColumns.push("actions");
            }
            this.dataSource = new AccountQueryStore(this.service, this.paginator, this.sort, this.AccountFilter);
        };
        /**
         * @return {?}
         */
        AccountTableComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.action.complete();
        };
        /**
         * @param {?} keyword
         * @return {?}
         */
        AccountTableComponent.prototype.reload = /**
         * @param {?} keyword
         * @return {?}
         */
        function (keyword) {
            this.AccountFilter.keyword = keyword;
            this.applyFilter(this.AccountFilter);
        };
        /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        AccountTableComponent.prototype.applyFilter = /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            this.dataSource.filterSubject.next(filter);
        };
        /**
         * @param {?=} type
         * @param {?=} partner
         * @return {?}
         */
        AccountTableComponent.prototype.onAction = /**
         * @param {?=} type
         * @param {?=} partner
         * @return {?}
         */
        function (type, partner) {
            if (type === void 0) { type = ""; }
            if (core.isDevMode()) {
                console.debug(TAG, "onAction", partner);
            }
            event.stopPropagation();
            this.fireAction({ type: type, partner: partner });
        };
        /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        AccountTableComponent.prototype.fireAction = /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        function (action) {
            this.action.emit(action);
        };
        AccountTableComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'crm-account-overview-table',
                        template: "<div class=\"table-layout-1\">\n    <mat-paginator color=\"accent\" #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n    </mat-paginator>\n    <mat-table #table [dataSource]=\"dataSource\" matSort matSortActive=\"lastName\" matSortDirection=\"asc\"\n        matSortDisableClear>\n        <!-- firstName Column -->\n        <ng-container matColumnDef=\"firstName\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.FIRST_NAME' | translate}}\n            </mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.firstName}}</span></mat-cell>\n        </ng-container>\n\n        <!-- lastName Column -->\n        <ng-container matColumnDef=\"lastName\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.LAST_NAME' | translate}}\n            </mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.lastName}}</span></mat-cell>\n        </ng-container>\n        <!-- companyName Column -->\n        <ng-container matColumnDef=\"companyName\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.COMPANY_NAME' | translate}}\n            </mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.companyName}}</span></mat-cell>\n        </ng-container>\n\n\n        <ng-container matColumnDef=\"partnerId\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.ID' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.info?.shortName || row.partnerId}}</span></mat-cell>\n        </ng-container>\n\n\n        <!-- role Column -->\n        <ng-container matColumnDef=\"role\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.ROLE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.role}}</span></mat-cell>\n        </ng-container>\n\n        <!-- preferredCommunicationChannel Column -->\n        <ng-container matColumnDef=\"preferredCommunicationChannel\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.COMMUNICATION_CHANNEL' | translate}}\n            </mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.preferredCommunicationChannel}}</span></mat-cell>\n        </ng-container>\n\n        <!-- mobile Column -->\n        <ng-container matColumnDef=\"mobile\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.MOBILE' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row.mobile}}</span></mat-cell>\n        </ng-container>\n\n        <!-- Owner column -->\n        <ng-container matColumnDef=\"created.user\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.OWNER' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span>{{row?.created?.user}}</span></mat-cell>\n        </ng-container>\n\n        <!-- status -->\n        <ng-container matColumnDef=\"status\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef>{{'PARTNER.HEADER.STATUS' | translate}}</mat-header-cell>\n            <mat-cell *matCellDef=\"let row\"><span></span></mat-cell>\n        </ng-container>\n\n\n        <!-- Custom Column -->\n        <ng-container *ngFor=\"let column of customColumns\" [cdkColumnDef]=\"column.columnDef\">\n            <mat-header-cell *cdkHeaderCellDef>{{ column.header }}</mat-header-cell>\n            <mat-cell *cdkCellDef=\"let row\">{{ column.cell(row) }}</mat-cell>\n        </ng-container>\n\n\n        <!-- status -->\n        <ng-container matColumnDef=\"actions\">\n            <mat-header-cell mat-sort-header *matHeaderCellDef></mat-header-cell>\n            <mat-cell *matCellDef=\"let row\">\n                <div fxLayout=\"row\" fxLayoutAlign=\"end\">\n                    <button mat-raised-button class=\"icon-btn2 primary-50-bg\" (click)=\"onAction('delete', row)\">\n                        <mat-icon color=\"warn\">\n                            delete\n                        </mat-icon>\n                    </button>\n                </div>\n            </mat-cell>\n        </ng-container>\n\n\n        <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n        <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('edit',row)\">\n        </mat-row>\n\n    </mat-table>\n\n</div>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["crm-account-overview-table{width:100%}crm-account-overview-table .mat-table{background:0 0;box-shadow:none}crm-account-overview-table .mat-table .mat-row{position:relative;cursor:pointer;min-height:64px}crm-account-overview-table .mat-table .mat-cell span{width:auto!important}"]
                    }] }
        ];
        /** @nocollapse */
        AccountTableComponent.ctorParameters = function () { return [
            { type: chainCrmAngularCore.AccountService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainCrmAngularCore.AccountService; })),] }] }
        ]; };
        AccountTableComponent.propDecorators = {
            displayedColumns: [{ type: core.Input }],
            customColumns: [{ type: core.Input }],
            AccountFilter: [{ type: core.Input }],
            action: [{ type: core.Output }],
            paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
            sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }]
        };
        return AccountTableComponent;
    }());
    if (false) {
        /** @type {?} */
        AccountTableComponent.prototype.dataSource;
        /** @type {?} */
        AccountTableComponent.prototype.displayedColumns;
        /** @type {?} */
        AccountTableComponent.prototype.customColumns;
        /** @type {?} */
        AccountTableComponent.prototype.AccountFilter;
        /** @type {?} */
        AccountTableComponent.prototype.action;
        /** @type {?} */
        AccountTableComponent.prototype.paginator;
        /** @type {?} */
        AccountTableComponent.prototype.sort;
        /**
         * @type {?}
         * @private
         */
        AccountTableComponent.prototype.service;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RelationQueryStore = /** @class */ (function (_super) {
        __extends(RelationQueryStore, _super);
        function RelationQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        /**
         * @protected
         * @return {?}
         */
        RelationQueryStore.prototype.queryTable = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryRelation(filter);
        };
        /**
         * Only include paginator to serverMutations. Sorting should be done client side
         * @protected
         */
        /**
         * Only include paginator to serverMutations. Sorting should be done client side
         * @protected
         * @return {?}
         */
        RelationQueryStore.prototype.initReloadMutations = /**
         * Only include paginator to serverMutations. Sorting should be done client side
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var dataMutations = [];
            if (this.paginator)
                dataMutations.push(this.paginator.page);
            if (this.filterSubject) {
                dataMutations.push(this.filterSubject);
            }
            return dataMutations;
        };
        return RelationQueryStore;
    }(chainBaseAngularStore.QueryTableSource));
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        RelationQueryStore.prototype.service;
        /**
         * @type {?}
         * @protected
         */
        RelationQueryStore.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        RelationQueryStore.prototype.sort;
        /**
         * @type {?}
         * @protected
         */
        RelationQueryStore.prototype.tableFilter;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TAG$1 = "RelationTableComponent";
    var RelationTableComponent = /** @class */ (function () {
        function RelationTableComponent(service, _route, overlay, _router) {
            this.service = service;
            this._route = _route;
            this.overlay = overlay;
            this._router = _router;
            //DataSource<any>;
            this.displayedColumns = ['role', 'selectedPartner', "classifier"];
            this.customColumns = [];
            this.action = new core.EventEmitter();
            this.relationFilter = {};
            this.PartnerId = null;
            /*        this._router.routeReuseStrategy.shouldReuseRoute = () => false;*/
        }
        // -----------------------------------------------------------------------------------------------------
        // @ Lifecycle hooks
        // -----------------------------------------------------------------------------------------------------
        // -----------------------------------------------------------------------------------------------------
        // @ Lifecycle hooks
        // -----------------------------------------------------------------------------------------------------
        /**
         * @return {?}
         */
        RelationTableComponent.prototype.ngOnInit = 
        // -----------------------------------------------------------------------------------------------------
        // @ Lifecycle hooks
        // -----------------------------------------------------------------------------------------------------
        /**
         * @return {?}
         */
        function () {
            var _this = this;
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                /** @type {?} */
                var abc = this.customColumns.map((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) { return c.columnDef; }));
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
                this.displayedColumns.push("actions");
            }
            else {
                this.displayedColumns.push("actions");
            }
            this._route.params.pipe().subscribe((/**
             * @param {?} params
             * @return {?}
             */
            function (params) {
                _this.relationFilter.targetOrSourceIds = [];
                _this.relationFilter.targetOrSourceIds.push(params.partnerId);
                if (_this.role) {
                    _this.relationFilter.role = _this.role;
                }
                _this.PartnerId = params.partnerId;
                _this.dataSource = new RelationQueryStore(_this.service, _this.paginator, _this.sort, _this.relationFilter);
            }));
        };
        /**
         * @return {?}
         */
        RelationTableComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.action.complete();
        };
        // -----------------------------------------------------------------------------------------------------
        // @ Event handlers
        // -----------------------------------------------------------------------------------------------------
        // -----------------------------------------------------------------------------------------------------
        // @ Event handlers
        // -----------------------------------------------------------------------------------------------------
        /**
         * @param {?=} type
         * @param {?=} relation
         * @return {?}
         */
        RelationTableComponent.prototype.onAction = 
        // -----------------------------------------------------------------------------------------------------
        // @ Event handlers
        // -----------------------------------------------------------------------------------------------------
        /**
         * @param {?=} type
         * @param {?=} relation
         * @return {?}
         */
        function (type, relation) {
            if (type === void 0) { type = ""; }
            if (core.isDevMode()) {
                console.debug(TAG$1, "onAction", relation);
            }
            event.stopPropagation();
            this.fireAction({ type: type, relation: relation });
        };
        /**
         * @param {?} relId
         * @param {?} event
         * @return {?}
         */
        RelationTableComponent.prototype.onDelete = /**
         * @param {?} relId
         * @param {?} event
         * @return {?}
         */
        function (relId, event) {
            event.stopPropagation();
            this.fireAction({ relId: relId, type: 'delete' });
        };
        /**
         * @return {?}
         */
        RelationTableComponent.prototype.reload = /**
         * @return {?}
         */
        function () {
            this.applyFilter(this.relationFilter);
        };
        /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        RelationTableComponent.prototype.applyFilter = /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            console.log("Appling the filter");
            this.dataSource.filterSubject.next(filter);
        };
        /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        RelationTableComponent.prototype.fireAction = /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        function (action) {
            this.action.emit(action);
        };
        /**
         * @param {?} id
         * @return {?}
         */
        RelationTableComponent.prototype.openPartnerDetailOverlay = /**
         * @param {?} id
         * @return {?}
         */
        function (id) {
            this.partnerDetailsRowId = id;
        };
        // -----------------------------------------------------------------------------------------------------
        // @ Util
        // -----------------------------------------------------------------------------------------------------
        // -----------------------------------------------------------------------------------------------------
        // @ Util
        // -----------------------------------------------------------------------------------------------------
        /**
         * @protected
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.isPartnerSource = 
        // -----------------------------------------------------------------------------------------------------
        // @ Util
        // -----------------------------------------------------------------------------------------------------
        /**
         * @protected
         * @param {?} row
         * @return {?}
         */
        function (row) {
            if (row.sourcePartner) {
                return row.sourcePartner.partnerId === this.PartnerId;
            }
            return false;
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.getSelectedPartnerName = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            /** @type {?} */
            var sourcePartner = row.sourcePartner;
            /** @type {?} */
            var targetPartner = row.targetPartner;
            return this.isPartnerSource(row) ? chainCrmAngularCore.AccountUtilities.getDisplayName(targetPartner) : chainCrmAngularCore.AccountUtilities.getDisplayName(sourcePartner);
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.getSelectedPartnerId = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            /** @type {?} */
            var sourcePartner = row.sourcePartner;
            /** @type {?} */
            var targetPartner = row.targetPartner;
            return this.isPartnerSource(row) ? (targetPartner.partnerId) : sourcePartner.partnerId;
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.getDisplayedRelationName = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            /** @type {?} */
            var config = chainCrmAngularCore.RelationConfigService.getRelationConfigForRole(row.role);
            if (!config) {
                return "undefined";
            }
            return this.isPartnerSource(row) ? config.relation : config.inverseRelation;
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.getDisplayedClassifier = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            if (!row['classifier']) {
                return "undefined";
            }
            return row.classifier;
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.getSelectedPartner = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            /** @type {?} */
            var sourcePartner = row.sourcePartner;
            /** @type {?} */
            var targetPartner = row.targetPartner;
            return this.isPartnerSource(row) ? targetPartner : sourcePartner;
        };
        /**
         * @param {?} action
         * @return {?}
         */
        RelationTableComponent.prototype.onOverlayAction = /**
         * @param {?} action
         * @return {?}
         */
        function (action) {
            if (action === 'close') {
                this.partnerDetailsRowId = "";
            }
        };
        /**
         * @param {?} row
         * @return {?}
         */
        RelationTableComponent.prototype.navigateToPartner = /**
         * @param {?} row
         * @return {?}
         */
        function (row) {
            this._router.navigate(['../', this.getSelectedPartnerId(row)], { relativeTo: this._route });
        };
        RelationTableComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'chain-relation-table',
                        template: "<mat-toolbar>\n    <mat-toolbar-row fxLayout fxLayoutAlign=\"space-between center\">\n\n        <ng-content></ng-content>\n\n        <mat-paginator color=\"accent\" #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n            <span>Test</span>\n        </mat-paginator>\n\n    </mat-toolbar-row>\n</mat-toolbar>\n\n\n<mat-table class=\"table-hover-1\" [dataSource]=\"dataSource\" matSort matSortActive=\"role\" matSortDirection=\"asc\"\n    matSortDisableClear>\n\n    <!-- role Column -->\n    <ng-container matColumnDef=\"role\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'RELATION.HEADER.RELATION' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"><span>{{getDisplayedRelationName(row)}}</span></mat-cell>\n    </ng-container>\n\n\n    <!-- classifier Column -->\n    <ng-container matColumnDef=\"classifier\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'RELATION.HEADER.CLASSIFIER' | translate}}\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"><span>{{row?.classifier}}</span></mat-cell>\n    </ng-container>\n\n\n\n\n    <!-- partnerSourceId Column -->\n    <ng-container matColumnDef=\"selectedPartner\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>Partner\n        </mat-header-cell>\n        <mat-cell *matCellDef=\"let row;let i = index;\">\n            <div fxLayout=\"row\" fxLayoutAlign=\"none center\">\n                <span fxFlex=\"50\">{{getSelectedPartnerName(row)}}</span>\n                <mat-icon #trigger=\"cdkOverlayOrigin\" cdkOverlayOrigin fxFlex=\"10\"\n                    (click)=\"openPartnerDetailOverlay(i); $event.stopPropagation()\" matTooltip=\"Open partner details\">\n                    info\n                </mat-icon>\n                <mat-icon #trigger=\"cdkOverlayOrigin\" cdkOverlayOrigin fxFlex=\"10\"\n                    (click)=\"navigateToPartner(row); $event.stopPropagation()\" matTooltip=\"Navigate to partner\">\n                    visibility\n                </mat-icon>\n            </div>\n            <ng-template #overlayRef (backdropClick)=\"partnerDetailsRowId = ''\" cdkConnectedOverlay\n                cdkConnectedOverlayBackdropClass=\"'backdrop'\" cdkConnectedOverlayHasBackdrop=\"true\"\n                [cdkConnectedOverlayOrigin]=\"trigger\" [cdkConnectedOverlayOpen]=\"partnerDetailsRowId === i\">\n\n                <div fxLayout=\"column\" class=\"primary-50-bg  scale-up-tl\">\n                    <div fxLayout fxLayoutAlign=\"end\" class=\"accent-A700 actions\">\n                        <mat-icon style=\"cursor:pointer; \" (click)=\"onOverlayAction('close')\">close</mat-icon>\n                    </div>\n                    <app-partner-info-view [partner]=\"getSelectedPartner(row)\" (onAction)=\"onOverlayAction($event)\">\n                    </app-partner-info-view>\n\n                </div>\n\n            </ng-template>\n\n\n        </mat-cell>\n    </ng-container>\n\n <!-- Custom Column -->\n    <ng-container *ngFor=\"let column of customColumns\" [cdkColumnDef]=\"column.columnDef\">\n        <mat-header-cell *cdkHeaderCellDef>{{ column.header }}</mat-header-cell>\n        <mat-cell *cdkCellDef=\"let row\">{{ column.cell(row) }}</mat-cell>\n      </ng-container>\n\n    <!-- delete Column -->\n    <ng-container matColumnDef=\"actions\">\n        <mat-header-cell *matHeaderCellDef></mat-header-cell>\n        <mat-cell *matCellDef=\"let row\">\n            <button mat-raised-button class=\"icon-btn2 primary-50-bg\" (click)=\"onDelete(row?.relationId, $event)\">\n                <mat-icon color=\"warn\" class=\"yukawa-navy-A700-fg\">\n                    delete\n                </mat-icon>\n            </button>\n        </mat-cell>\n    </ng-container>\n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('edit',row)\">\n    </mat-row>\n\n</mat-table>",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["chain-relation-table{width:100%}chain-relation-table .mat-table{background:0 0;box-shadow:none}chain-relation-table .mat-table .mat-row{position:relative;cursor:pointer;min-height:64px}chain-relation-table .mat-table .mat-cell:last-child button{float:right}chain-relation-table .mat-table .mat-cell span{width:auto!important}chain-relation-table .mat-column-selectedPartner{-webkit-box-flex:0!important;flex:0 0 35%!important}"]
                    }] }
        ];
        /** @nocollapse */
        RelationTableComponent.ctorParameters = function () { return [
            { type: chainCrmAngularCore.RelationService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainCrmAngularCore.RelationService; })),] }] },
            { type: router.ActivatedRoute, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return router.ActivatedRoute; })),] }] },
            { type: overlay.Overlay, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return overlay.Overlay; })),] }] },
            { type: router.Router, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return router.Router; })),] }] }
        ]; };
        RelationTableComponent.propDecorators = {
            dataSource: [{ type: core.Input }],
            displayedColumns: [{ type: core.Input }],
            customColumns: [{ type: core.Input }],
            action: [{ type: core.Output }],
            paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
            sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }],
            role: [{ type: core.Input }]
        };
        return RelationTableComponent;
    }());
    if (false) {
        /** @type {?} */
        RelationTableComponent.prototype.dataSource;
        /** @type {?} */
        RelationTableComponent.prototype.displayedColumns;
        /** @type {?} */
        RelationTableComponent.prototype.customColumns;
        /** @type {?} */
        RelationTableComponent.prototype.action;
        /** @type {?} */
        RelationTableComponent.prototype.paginator;
        /** @type {?} */
        RelationTableComponent.prototype.sort;
        /** @type {?} */
        RelationTableComponent.prototype.relationFilter;
        /** @type {?} */
        RelationTableComponent.prototype.PartnerId;
        /** @type {?} */
        RelationTableComponent.prototype.role;
        /** @type {?} */
        RelationTableComponent.prototype.partnerDetailsRowId;
        /**
         * @type {?}
         * @protected
         */
        RelationTableComponent.prototype.service;
        /**
         * @type {?}
         * @private
         */
        RelationTableComponent.prototype._route;
        /** @type {?} */
        RelationTableComponent.prototype.overlay;
        /**
         * @type {?}
         * @private
         */
        RelationTableComponent.prototype._router;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ContactLogQueryStore = /** @class */ (function (_super) {
        __extends(ContactLogQueryStore, _super);
        function ContactLogQueryStore(service, paginator, sort, tableFilter) {
            var _this = _super.call(this, paginator, sort, tableFilter) || this;
            _this.service = service;
            _this.paginator = paginator;
            _this.sort = sort;
            _this.tableFilter = tableFilter;
            _this.filterSubject = new rxjs.BehaviorSubject(tableFilter);
            return _this;
        }
        /**
         * @protected
         * @return {?}
         */
        ContactLogQueryStore.prototype.queryTable = /**
         * @protected
         * @return {?}
         */
        function () {
            /** @type {?} */
            var filter = this.findFilter();
            this.applyFilter(filter);
            if (filter.keyword)
                filter.keyword += '*';
            return this.service.queryContactLog(filter);
        };
        return ContactLogQueryStore;
    }(chainBaseAngularStore.QueryTableSource));
    if (false) {
        /**
         * @type {?}
         * @protected
         */
        ContactLogQueryStore.prototype.service;
        /**
         * @type {?}
         * @protected
         */
        ContactLogQueryStore.prototype.paginator;
        /**
         * @type {?}
         * @protected
         */
        ContactLogQueryStore.prototype.sort;
        /**
         * @type {?}
         * @protected
         */
        ContactLogQueryStore.prototype.tableFilter;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var TAG$2 = "ContactLogTableComponent";
    var ContactLogTableComponent = /** @class */ (function () {
        function ContactLogTableComponent(service, _route) {
            var _this = this;
            this.service = service;
            this._route = _route;
            this.Partners = [];
            this.displayedColumns = ['info.shortName', 'location', 'status', 'dateRange'];
            this.customColumns = [];
            this.action = new core.EventEmitter();
            this.contactLogFilter = {};
            //  this.dataSource =  new ContactLogQueryStore(this.service,this.paginator, this.sort)
            this._route.params.pipe().subscribe((/**
             * @param {?} params
             * @return {?}
             */
            function (params) {
                _this.contactLogFilter.participantId = params.partnerId;
                _this.dataSource = new ContactLogQueryStore(_this.service, _this.paginator, _this.sort, _this.contactLogFilter);
            }));
        }
        /**
         * @return {?}
         */
        ContactLogTableComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _a;
            if (this.customColumns && this.customColumns.length > 0) {
                /** @type {?} */
                var abc = this.customColumns.map((/**
                 * @param {?} c
                 * @return {?}
                 */
                function (c) { return c.columnDef; }));
                (_a = this.displayedColumns).push.apply(_a, __spread(abc));
            }
            else {
            }
        };
        /**
         * @return {?}
         */
        ContactLogTableComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.action.complete();
        };
        /**
         * @return {?}
         */
        ContactLogTableComponent.prototype.reload = /**
         * @return {?}
         */
        function () {
            this.applyFilter(this.contactLogFilter);
        };
        /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        ContactLogTableComponent.prototype.applyFilter = /**
         * @protected
         * @param {?} filter
         * @return {?}
         */
        function (filter) {
            this.dataSource.filterSubject.next(filter);
        };
        /**
         * @param {?=} type
         * @param {?=} contactLog
         * @return {?}
         */
        ContactLogTableComponent.prototype.onAction = /**
         * @param {?=} type
         * @param {?=} contactLog
         * @return {?}
         */
        function (type, contactLog) {
            if (type === void 0) { type = ""; }
            event.stopPropagation();
            if (core.isDevMode()) {
                console.debug(TAG$2, "onAction", contactLog);
            }
            event.stopPropagation();
            this.fireAction({ type: type, contactLog: contactLog });
        };
        /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        ContactLogTableComponent.prototype.fireAction = /**
         * @protected
         * @param {?} action
         * @return {?}
         */
        function (action) {
            this.action.emit(action);
        };
        /**
         * @param {?} participantId
         * @return {?}
         */
        ContactLogTableComponent.prototype.partnerName = /**
         * @param {?} participantId
         * @return {?}
         */
        function (participantId) {
            /** @type {?} */
            var partner = this.Partners.find((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.partnerId == participantId; }));
            return (partner.firstName ? partner.firstName : partner.companyName) + " " + (partner.lastName ? partner.lastName : "");
        };
        ContactLogTableComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'chain-contact-log-table',
                        template: "\n<!-- <mat-paginator #paginator [pageIndex]=\"0\" [pageSize]=\"10\" [pageSizeOptions]=\"[5, 10, 25, 100]\">\n</mat-paginator> -->\n\n<mat-table #table [dataSource]=\"dataSource\" matSort matSortActive=\"dateRange\" matSortDirection=\"asc\" matSortDisableClear>\n\n    <!-- shortName Column -->\n    <ng-container matColumnDef=\"info.shortName\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'CONTACT_LOG.HEADER.SHORT_NAME' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"> <span>{{row?.info?.shortName}}</span></mat-cell>\n    </ng-container>\n\n    <!-- communicationChannel Column -->\n    <ng-container matColumnDef=\"communicationChannel\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'CONTACT_LOG.HEADER.COMMUNICATION_CHANNEL' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"> <span>{{row.communicationChannel}}</span></mat-cell>\n    </ng-container>\n\n     <!-- status Column -->\n     <ng-container matColumnDef=\"status\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'CONTACT_LOG.HEADER.STATUS' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"> <span>{{row.status}}</span></mat-cell>\n    </ng-container>\n\n     <!-- location Column -->\n     <ng-container matColumnDef=\"location\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'CONTACT_LOG.HEADER.LOCATION' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"> <span>{{row.location}}</span></mat-cell>\n    </ng-container>\n\n    <!-- dateRange Column -->\n    <ng-container matColumnDef=\"dateRange\">\n        <mat-header-cell mat-sort-header *matHeaderCellDef>{{'CONTACT_LOG.HEADER.DATE' | translate}}</mat-header-cell>\n        <mat-cell *matCellDef=\"let row\"> <span>{{row.dateRange?.from | date}}&nbsp;-&nbsp;{{row.dateRange?.to | date}}</span></mat-cell>\n    </ng-container>\n\n     <!-- Custom Column -->\n     <ng-container *ngFor=\"let column of customColumns\" [cdkColumnDef]=\"column.columnDef\">\n        <mat-header-cell *cdkHeaderCellDef>{{ column.header }}</mat-header-cell>\n        <mat-cell *cdkCellDef=\"let row\">{{ column.cell(row) }}</mat-cell>\n      </ng-container>\n\n   \n\n    <mat-header-row *matHeaderRowDef=\"displayedColumns\"></mat-header-row>\n    <mat-row *matRowDef=\"let row; columns: displayedColumns;\" (click)=\"onAction('edit',row)\"  >\n    </mat-row>\n\n</mat-table>\n",
                        encapsulation: core.ViewEncapsulation.None,
                        styles: ["contact-log-table{width:100%}contact-log-table .mat-table{background:0 0;box-shadow:none}contact-log-table .mat-table .mat-row{position:relative;cursor:pointer;min-height:64px}.page-inner mat-table.mat-table{background:0 0!important;margin-bottom:30px}.page-inner mat-table.mat-table mat-header-row,.page-inner mat-table.mat-table mat-row{border:0;min-height:initial}.page-inner mat-table.mat-table mat-row:nth-child(2n){background-color:#fff}.page-inner mat-table.mat-table mat-row mat-cell{color:#143c27;font-size:16px;font-weight:700;padding:15px 10px;height:initial;line-height:initial;min-height:initial}.page-inner mat-table.mat-table mat-header-row mat-header-cell:first-child,.page-inner mat-table.mat-table mat-row mat-cell:first-child{padding-left:40px}.page-inner mat-table.mat-table mat-header-row mat-header-cell:last-child,.page-inner mat-table.mat-table mat-row mat-cell:last-child{padding-right:100px}mat-table.mat-table mat-header-row{background-color:#143c27}mat-table.mat-table mat-header-row mat-header-cell{color:#fff!important;font-weight:700;font-size:16px;padding:15px 10px}.page-inner mat-table.mat-table mat-row mat-cell button span{width:auto!important;white-space:normal}.page-inner mat-table.mat-table mat-row mat-cell button{box-shadow:none!important;background-color:transparent;color:#143c27}.page-inner mat-table.mat-table mat-row mat-cell>span:not(.status){display:block;width:100px;overflow:hidden;white-space:nowrap;text-overflow:ellipsis}.page-inner mat-table.mat-table mat-row mat-cell span.status{height:14px;width:14px;padding:0;line-height:initial}@media (max-width:600px){.page-inner mat-table.mat-table mat-header-row mat-header-cell:first-child,.page-inner mat-table.mat-table mat-row mat-cell:first-child{padding-left:20px}.page-inner mat-table.mat-table mat-header-row mat-header-cell:last-child,.page-inner mat-table.mat-table mat-row mat-cell:last-child{padding-right:20px}.page-inner mat-paginator,.page-inner mat-table.mat-table{width:150%}}@media (max-width:490px){.page-inner mat-paginator,.page-inner mat-table.mat-table{width:200%}}"]
                    }] }
        ];
        /** @nocollapse */
        ContactLogTableComponent.ctorParameters = function () { return [
            { type: chainCrmAngularCore.ContactLogService, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return chainCrmAngularCore.ContactLogService; })),] }] },
            { type: router.ActivatedRoute, decorators: [{ type: core.Inject, args: [core.forwardRef((/**
                             * @return {?}
                             */
                            function () { return router.ActivatedRoute; })),] }] }
        ]; };
        ContactLogTableComponent.propDecorators = {
            dataSource: [{ type: core.Input }],
            Partners: [{ type: core.Input }],
            displayedColumns: [{ type: core.Input }],
            customColumns: [{ type: core.Input }],
            action: [{ type: core.Output }],
            paginator: [{ type: core.ViewChild, args: [paginator.MatPaginator, { static: true },] }],
            sort: [{ type: core.ViewChild, args: [sort.MatSort, { static: true },] }]
        };
        return ContactLogTableComponent;
    }());
    if (false) {
        /** @type {?} */
        ContactLogTableComponent.prototype.dataSource;
        /** @type {?} */
        ContactLogTableComponent.prototype.Partners;
        /** @type {?} */
        ContactLogTableComponent.prototype.displayedColumns;
        /** @type {?} */
        ContactLogTableComponent.prototype.customColumns;
        /** @type {?} */
        ContactLogTableComponent.prototype.action;
        /** @type {?} */
        ContactLogTableComponent.prototype.paginator;
        /** @type {?} */
        ContactLogTableComponent.prototype.sort;
        /** @type {?} */
        ContactLogTableComponent.prototype.contactLogFilter;
        /**
         * @type {?}
         * @private
         */
        ContactLogTableComponent.prototype.service;
        /**
         * @type {?}
         * @private
         */
        ContactLogTableComponent.prototype._route;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // services
    var CRMCompModule = /** @class */ (function () {
        function CRMCompModule() {
        }
        CRMCompModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule,
                            datepicker.MatDatepickerModule,
                            button.MatButtonModule,
                            icon.MatIconModule,
                            core$2.MatRippleModule,
                            slideToggle.MatSlideToggleModule,
                            table$1.MatTableModule,
                            sort.MatSortModule,
                            tooltip.MatTooltipModule,
                            flexLayout.FlexLayoutModule,
                            menu.MatMenuModule,
                            checkbox.MatCheckboxModule,
                            http.HttpClientModule,
                            overlay.OverlayModule,
                            paginator.MatPaginatorModule,
                            table.CdkTableModule,
                            core$1.TranslateModule.forChild()
                        ],
                        declarations: [
                            AccountTableComponent, RelationTableComponent, ContactLogTableComponent
                        ],
                        exports: [
                            AccountTableComponent, RelationTableComponent, ContactLogTableComponent
                        ],
                        providers: [],
                        entryComponents: [],
                        schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                    },] }
        ];
        return CRMCompModule;
    }());

    exports.AccountQueryStore = AccountQueryStore;
    exports.AccountTableComponent = AccountTableComponent;
    exports.CRMCompModule = CRMCompModule;
    exports.ContactLogQueryStore = ContactLogQueryStore;
    exports.ContactLogTableComponent = ContactLogTableComponent;
    exports.RelationQueryStore = RelationQueryStore;
    exports.RelationTableComponent = RelationTableComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=yukawa-chain-crm-angular-comp.umd.js.map
